
SLASH_SIMPLEVIGNETTE1, SLASH_SIMPLEVIGNETTE2 = '/sv', '/simplevignette';

-- by Kaemin

function SlashCmdList.SIMPLEVIGNETTE(msg, editbox)
	if msg == nil or msg == "" or msg == "menu" or msg == "options" or msg == "?" or msg == "help" then
		InterfaceOptionsFrame_OpenToCategory(SV_PanelName);
		InterfaceOptionsFrame_OpenToCategory(SV_PanelName);
		SVSoundNameShow:SetText(svsoundname);
	else
		DEFAULT_CHAT_FRAME:AddMessage("SimpleVignette " ..GetAddOnMetadata("SimpleVignette", "Version").. ": /sv for options.");
	end
end

local f = CreateFrame("Frame")
f:RegisterEvent("VIGNETTE_MINIMAP_UPDATED")
f:SetScript("OnEvent", function(self, event, vignetteInstanceID, onMiniMap)
	if vignetteInstanceID and onMiniMap then
		if SVInstanceID == vignetteInstanceID then
		else
			SVInstanceID = vignetteInstanceID;
			RareObjectName = "";
			local SV_Table = C_VignetteInfo.GetVignetteInfo(vignetteInstanceID)
			if not SV_Table then return end
			local name = SV_Table.name
			if name then
--				Excluded Items List follows
				if name == "Invasion Site"    
					or name == "Legion Structure"
					or name == "Kukuru's Treasure Cache"
					or name == "Scouting Map"
					or name == "Map of Zandalar"
					then return
				end
				if not svchests then
					if string.find (name, "Treasure")
						or string.find (name, "Statue")
						or string.find (name, "Garrison Cache") then
							return
					end
				end
				RareObjectName = name;
			end
			if not name then
				RareObjectName = "Rare";
			end
			SVOutputOptions();
		end
	end
end)

function ChangeSoundClick()
	if svsoundnum==0 or svsoundnum==1 then 
		svsoundnum = 2; 
		svsoundname = "Alarm"; 
		svsoundfile = "Interface\\AddOns\\SimpleVignette\\sounds\\alarm.mp3"; 
		SVSoundNameShow:SetText(svsoundname); 
	elseif svsoundnum==2 then
		svsoundnum = 3; 
		svsoundname = "Beep"; 
		svsoundfile = "Interface\\AddOns\\SimpleVignette\\sounds\\beep.mp3"; 
		SVSoundNameShow:SetText(svsoundname);
	elseif svsoundnum==3 then
		svsoundnum = 4; 
		svsoundname = "Speech"; 
		svsoundfile = "Interface\\AddOns\\SimpleVignette\\sounds\\agnes_beep.mp3"; 
		SVSoundNameShow:SetText(svsoundname);
	elseif svsoundnum==4 then
		svsoundnum = 5; 
		svsoundname = "Party"; 
		svsoundfile = "Interface\\AddOns\\SimpleVignette\\sounds\\party.mp3"; 
		SVSoundNameShow:SetText(svsoundname);
	elseif svsoundnum==5 then
		svsoundnum = 6; 
		svsoundname = "Bike"; 
		svsoundfile = "Interface\\AddOns\\SimpleVignette\\sounds\\bike.mp3"; 
		SVSoundNameShow:SetText(svsoundname);
	elseif svsoundnum==6 then
		svsoundnum = 7; 
		svsoundname = "Chime"; 
		svsoundfile = "Interface\\AddOns\\SimpleVignette\\sounds\\chime.mp3"; 
		SVSoundNameShow:SetText(svsoundname);
	elseif svsoundnum==7 then
		svsoundnum = 8; 
		svsoundname = "Woop"; 
		svsoundfile = "Interface\\AddOns\\SimpleVignette\\sounds\\woop.mp3"; 
		SVSoundNameShow:SetText(svsoundname);
	elseif svsoundnum==8 then
		svsoundnum = 1;
		svsoundname = "Signal";
		svsoundfile = "Interface\\AddOns\\SimpleVignette\\sounds\\other_alarm.mp3";
		SVSoundNameShow:SetText(svsoundname);
	end
end

function TestSoundClick()
	if (svsound) then
		PlaySoundFile(svsoundfile);
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00" ..svsoundname.." spotted!|r");
		SVMessageFrame:AddMessage(svsoundname.. " spotted!", 0, 1, 0, .8, .5);
	else
		DEFAULT_CHAT_FRAME:AddMessage("SimpleVignette: Sounds are |cffff0000Disabled|r.");
	end
end

function SVSound_Check()
	SoundSelectButton:SetScript("PostClick", function(self)
		if self:GetChecked() then
			svsound = true;
		else 
			svsound = false;
		end
	end)
end

function SVChest_Check()
	ChestSelectButton:SetScript("PostClick", function(self)
		if self:GetChecked() then
			svchests = true;
		else 
			svchests = false;
		end
	end)
end

function SVOutputOptions()
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00"..RareObjectName.." spotted!|r");
			SVMessageFrame:AddMessage(RareObjectName.." spotted!", 0, 1, 0, .8, .5)
	if (svsound) then
		PlaySoundFile(svsoundfile);
	end
end

function SV_MenuPanel(SV_Panel)
	SV_Panel.name = "SimpleVignette " ..GetAddOnMetadata("SimpleVignette", "Version");
	SV_Panel.okay = function (self) SV_MenuPanel_Close(); end;
    SV_Panel.cancel = function (self) SV_MenuPanel_CancelOrLoad(); end;
	SVSoundNameShow:SetText(svsoundname);
	InterfaceOptions_AddCategory(SV_Panel);
end

function SV_MenuPanel_Close()
	if SVOptions_Frame:IsShown() then
		SVOptions_Frame:Hide();
	end
end

function SV_MenuPanel_CancelOrLoad()
	if SVOptions_Frame:IsShown() then
		SVOptions_Frame:Hide();
	end
end

function SimpleVignette_OnLoad(SV_Panel)
	local fframe = CreateFrame("Frame")
	fframe:RegisterEvent("ADDON_LOADED");
	fframe:SetScript("OnEvent", function(self, event, arg1)
		if event == "ADDON_LOADED" and arg1 == "SimpleVignette" then
			SVOptions_Frame:SetScale(.75);
			if svchests == nil then
				svchests = true;
			end
			if svsound == nil then
				svsound = true;
				svsoundd = "true";
			elseif svsound ~= nil then
				if (svsound) then
					svsoundd = "true";
				elseif not svsound then
					svsoundd = "false";
				end
			end
			if svsoundfile == nil then
				svsoundfile = "Interface\\AddOns\\SimpleVignette\\sounds\\beep.mp3";
				svsoundnum = 3;
				svsoundname = "Beep";
			end
			if (svchests) then
				ChestSelectButton:SetChecked(true);
			else
				ChestSelectButton:SetChecked(false);
			end
			if (svsound) then
				SoundSelectButton:SetChecked(true);
			else
				SoundSelectButton:SetChecked(false);
			end
		end
	end)
	SVOptions_Frame:Hide();
	SV_PanelName = SV_Panel
	SV_MenuPanel(SV_Panel);
	SVInstanceID = 0;
	DEFAULT_CHAT_FRAME:AddMessage("SimpleVignette " ..GetAddOnMetadata("SimpleVignette", "Version").. " loaded: /sv for options");
end
